<template>
  <q-layout view="hHh lpR fFf">
    <q-page-container>

      <q-header elevated>
        <Toolbar 
          :showAdmin="isAdmin" 
          :showAllUsersCb="toggleShowAll" 
          :showAllUsersVal="showAllIfAdmin" 
          :hasBackButton="false" 
          :showContacts="true" 
          :pageTitle="$t('dashboard.page_title')" />      
      </q-header>

      <q-page class="pl-fullpage">
        <ConferenceList :conferences="liveConferences" :isAdmin="isAdmin && showAllIfAdmin" :creators="creators"
          :loading="liveConferences.loading == true || creators.loading == true"
          :onClick="(id) => handleConferenceClick('Live', id)" class="q-px-none" type="Live" />
        <ConferenceList :conferences="upcomingConferences" :isAdmin="isAdmin && showAllIfAdmin" :creators="creators"
          :loading="upcomingConferences.loading == true || creators.loading == true"
          :onClick="(id) => handleConferenceClick('Upcoming', id)" type="Upcoming" />
        <ConferenceList :conferences="completeConferences" :isAdmin="isAdmin && showAllIfAdmin" :creators="creators"
          :loading="completeConferences.loading == true || creators.loading == true"
          :onClick="(id) => handleConferenceClick('Complete', id)" type="Complete" />

        <q-page-sticky position="bottom-right" class="pl-fullpage">
          <q-btn @click="handleScheduleSessionClick" fab color="primary" class="q-ma-sm">
            <div class="q-ml-sm">
              {{ $t("dashboard.schedule_conference_action") }}
            </div>
            <q-icon class="q-pl-sm" name="add" />
          </q-btn>
        </q-page-sticky>
      </q-page>
    </q-page-container>
  </q-layout>
</template>

<script>
import { auth, db } from "../firebase";
import ConferenceList from "../components/ConferenceList.vue";
import Toolbar from "../components/Toolbar.vue";

export default {
  data()
  {
    return {
      liveConferences: { loading: true },
      completeConferences: { loading: true },
      upcomingConferences: { loading: true },
      user: { loading: true },
      creators: { loading: true },
      isAdmin: false,
      showAllIfAdmin: false,
      langs: ['en', 'ne'],
      showChangeLang: false
    };
  },
  async created()
  {

    let token = await auth.currentUser.getIdTokenResult(true);
    this.isAdmin = token.claims.admin ?? false;
    if (this.isAdmin && this.showAllIfAdmin)
    {
      this.bindShowAll();
    }
    else
    {
      this.bindUserData();
    }

    this.$rtdbBind("user", db.ref(`Users/${auth.currentUser.uid}`));
  },

  methods: {
    toggleShowAll()
    {
      this.showAllIfAdmin = !this.showAllIfAdmin;
      this.$rtdbUnbind("upcomingConferences");
      this.$rtdbUnbind("completeConferences");
      this.$rtdbUnbind("liveConferences");
      if (this.isAdmin && this.showAllIfAdmin)
      {
        this.bindShowAll();
      }
      else
      {
        this.bindUserData();
      }
    },
    bindShowAll()
    {
      let creatorPromises = [];
      creatorPromises.push(this.$rtdbBind(
        "upcomingConferences",
        db.ref("Conferences/Upcoming")
      ).then(async res =>
      {
        await this.storeCreators(res.val());
      }));

      creatorPromises.push(this.$rtdbBind(
        "completeConferences",
        db.ref("Conferences/Complete")
      ).then(async res =>
      {
        await this.storeCreators(res.val());
      }));

      creatorPromises.push(this.$rtdbBind(
        "liveConferences",
        db.ref("Conferences/Live")
      ).then(async res =>
      {
        await this.storeCreators(res.val());
      }));

      Promise.all(creatorPromises).then(() =>
      {
        this.creators.loading = false;
      });
    },
    bindUserData()
    {
      this.creators.loading = false;
      this.$rtdbBind(
        "upcomingConferences",
        db
          .ref("Conferences/Upcoming")
          .orderByChild("Owner")
          .equalTo(auth.currentUser.uid)
      )

      this.$rtdbBind(
        "completeConferences",
        db
          .ref("Conferences/Complete")
          .orderByChild("Owner")
          .equalTo(auth.currentUser.uid)
      );

      this.$rtdbBind(
        "liveConferences",
        db
          .ref("Conferences/Live")
          .orderByChild("Owner")
          .equalTo(auth.currentUser.uid)
      );
    },
    storeCreators(conferences)
    {
      let promises = [];
      for (const confId in conferences) 
      {
        let authorId = conferences[confId].Owner;
        if (!this.creators[authorId])
        {
          this.creators[authorId] = this.$t("loading");
          promises.push((async () =>
          {
            let thisCreator = (await db.ref(`Users/${authorId}`).get()).val();
            if (thisCreator)
              this.creators[authorId] = `${thisCreator.Name} (${thisCreator.Email})`;
          })());
        }
      }

      return Promise.all(promises);
    },
    handleScheduleSessionClick()
    {
      this.$router.push({
        path: "/schedule",
        props: {
          contacts: this.user.Contacts || {},
        },
      })
    },
    // Conference type is 'Upcoming', 'Complete' or 'Live'
    handleConferenceClick(conferenceType, id)
    {
      if (conferenceType === "Upcoming")
      {
        this.$router.push({
          path: `upcoming/${id}`,
        });
      } else if (conferenceType === "Live")
      {
        this.$router.push({
          path: `conference/${id}`,
        });
      } else if (conferenceType === "Complete")
      {
        this.$router.push({
          path: `recordings/${id}`,
        });
      }
    }
  },
  components: {
    ConferenceList,
    Toolbar
  },
};
</script>
